module Program.Iterator where {

;import Control.Monad.ST
;import Data.STRef
;import Data.Array.ST
;import Data.Array as A
;import ImpList
;
;import Language.Haskell.TH;

import Language.Haskell.ER.Syntax;
import Language.Haskell.ER.HaskellRewrite;
import Language.Haskell.ER.MiscRewrite;
import Language.Haskell.ER.Utils;
import Language.Haskell.ER.Frees;
defns = $(quoteModule "main" "Iterator" [d|
-- automatically included


data Iterator s a = Iterator (STRef s Int) Int (Array Int a)

listToIterator :: [a] -> ST s (Iterator s a)
listToIterator xs = do
   ref <- newSTRef 0
   return $ Iterator ref (length xs) (listArray (0,length xs - 1) xs)


iteratorToList :: Iterator s a -> ST s [a]
iteratorToList (Iterator ref _ arr) = do
  n <- readSTRef ref
  return $ drop n $ elems arr


next :: Iterator s a -> ST s (Maybe a)
next (Iterator ref len arr) = do
  n <- readSTRef ref
  if n < len
     then do writeSTRef ref (succ n)
     	     return $ Just (arr A.! n)
     else do return $ Nothing

iteratorCase :: [a] -> (Iterator s a -> ST s b) -> ST s b
iteratorCase xs fn = (do
    ixs <- listToIterator xs
    fn ixs)


test = do
  lst <- listToIterator [1..5]
  vs <- sequence $ take 10 $ repeat (next lst)
  return vs

data Iterator' a = Iterator' Int Int (Array Int a)	-- varation of Iterator


iteratorToIterator' :: Iterator s a -> ST s (Iterator' a)
iteratorToIterator' (Iterator ref len arr) = do
  n <- readSTRef ref
  return $ Iterator' n len arr

iterator'ToList :: Iterator' a -> [a]
iterator'ToList  (Iterator' n len arr) = drop n $ elems arr

iteratorCase' :: Iterator' a -> (Iterator s a -> ST s b) -> ST s b
iteratorCase' (Iterator' n len arr) fn = (do
    ref <- newSTRef n
    fn (Iterator ref len arr))


myListBuildingToIterator :: (forall s . MyList s a -> ST s ()) 
			 -> ST s (Iterator s a)
myListBuildingToIterator m =
  listToIterator (ImpList.myListBuildingToList m)

{-
iteratorCaseWithImpList :: (forall s . MyList s a -> ST s ()) 
			-> (Iterator s a -> ST s b)
			-> 
-}
|])
}

